import React, { useEffect, useState } from 'react';
import {
  KeyboardAvoidingView,
  Platform,
  SafeAreaView,
  Keyboard,
  Image,
  TouchableOpacity,
  View,
  Text,
  TextInput,
  StyleSheet,
  ScrollView
} from 'react-native';

interface BioProps {
  onChangeText: (params: any) => any;
  value: string;
  onPress: (params: any) => any;
  onBlur: (params: any) => any;
  onChange: (params: any) => any;
  onFocus: (params: any) => any;
  buttonText: string;
  source?: JSX.Element;
  keyboardType: any;
  input: any;
  editable: boolean;
  placeholder: string;
  multiline: boolean;
  autoCapitalize: any;
  returnKeyType: any;
  placeholderTextColor: string;
  numberOfLines: number;
  maxLength: number;
  autoFocus: boolean;
  blurOnSubmit: boolean;
  enablesReturnKeyAutomatically: boolean;
  returnKeyLabel: string;
  secureTextEntry: boolean;
  textAlign: any;
  ImageViewStyle: any;
  ContainerViewStyle: any;
  ImageStyle: any;
  MainView: any;
  TextStyle: any;
  InputBoxStyle: any;
  ButtonViewStyle: any;
  ButtonTextStyle: any;
  RequestButtonText:string
  button: boolean;
  SignupButton: boolean;
  SignupTextStyle: any;
  SingupStyle: any;
  SingupText: string;
  Singup: string;
  SingupClick: (params: any) => any;
  Login: string;
  valueOTP: string;
  onChangeTextOTP: (params: any) => any;
  placeholderOTP: string;
  placeholderTextColorOTP: string;
  editableOTP: boolean;
  autoFocusOTP: boolean;
  blurOnSubmitOTP: boolean;
  enablesReturnKeyAutomaticallyOTP: boolean;
  onBlurOTP: (params: any) => any;
  onFocusOTP: (params: any) => any;
  onChangeOTP: (params: any) => any;
  secureTextEntryOTP: boolean;
  ResendOTP: string;
  DontOTP: string;
  ResendButtonStyle: any;
  resendText:string
  buttonTextOTP: string;
  onPressOTP: (params: any) => any;
  ResendButtonClick: (params: any) => any;
  LoginTextOTP: string;
  modalVisible: boolean;
  doneButton: (params: any) => any;
  Texttitle: string;
  SocialIconStyle: any;
  RegisterText: string;
  RegisterTextStyle: any;
  TexttitleStyle: any;
  OTPNumber:string
  InputBoxStyleOTP:any
  MainRegisterText:string
  MainRegisterTextStyle:any
  inputContainerStyle:any
  GoogleButtonClick:(params: any) => any;
  FbButtonClick:(params: any) => any;
  AppButtonClick:(params: any) => any;
  RegisterTextClick:(params: any) => any;
}

const Sandy: React.FC<BioProps> = (props): JSX.Element => {
// const[timer,setTimer] = useState('')
  const [modalVisible, setModalVisible] = useState(false);
  useEffect(() => {
    const keyboardDidShowListener = Keyboard.addListener(
      'keyboardDidShow',
      () => {
        // setKeyboardVisible(true); // or some other action
      }
    );
    const keyboardDidHideListener = Keyboard.addListener(
      'keyboardDidHide',
      () => {
        // setKeyboardVisible(false); // or some other action
      }
    );

    return () => {
      keyboardDidHideListener.remove();
      keyboardDidShowListener.remove();
    };
  }, []);

  let OTPNumberValue = props.OTPNumber?props.OTPNumber:''
  

//   const OTPNumber=(item)=>{
//     console.log("itemeee",item)
//     OTPNumberValue =item
//     // const Code = props.OTPNumber.split(" ");
// console.log(OTPNumberValue[4])
   
 
//   }

  // useEffect(() => {
  //   // timerValue();
  //   props.OTPNumber?OTPNumberValue=props.OTPNumber:null
    
  // }, []);

  // const timerValue = () => {
  //   if (modalVisible == true) {
  //     let timeval = 10;
  //     let testTime = setInterval(function () {
  //       setTimer(--timeval);
  //       if (timeval == 0) {
  //         clearInterval(testTime);
  //       }
  //     }, 1000);
  //   } else {
  //     console.log('not time');
  //   }
  // };
  // console.log("timer",timer)


  return (
    <>
      <SafeAreaView style={{ flex: 1 }}>
        <KeyboardAvoidingView
          behavior={Platform.OS == 'android' ? 'height' : 'padding'}
        >
          <ScrollView>
          <View
            style={[
              {
                height: '100%',
                width: '100%',
                // justifyContent: 'center',
              },
              props.MainView,
            ]}
          >
         
              <View
                style={[
                  {
                    // height: isKeyboardVisible ? '40%' : '60%',
                    width: '95%',
                    alignSelf: 'center',
                  },
                  props.ImageViewStyle,
                ]}
              >
                <Image
                  source={props.source ? props.source : require('./a.jpeg')}
                  style={[
                   
                    {
                      height: 50,
                      width: 220,
                    },
                    props.ImageStyle,
                  ]}
                />
              </View>
          
          
              <View style={[styles.viewa, props.ContainerViewStyle]}>
                <>
                  <Text style={[styles.Logintitle, props.TextStyle]}>
                    {props.Login || 'Login'}
                  </Text>
                  <Text style={[styles.Texttitle, props.TexttitleStyle]}>
                    {props.Texttitle ||
                      'Build your ideas into future ready digital apps'}
                  </Text>
                  <Text style={[styles.RegisterText, props.RegisterTextStyle]}>
                    {props.RegisterText ||
                      "If you don't have an account register, You can "}
                    <Text
                    onPress={props.RegisterTextClick?props.RegisterTextClick:()=>{}}
                      style={[
                        styles.RegisterText,
                        props.MainRegisterTextStyle,
                        { color: 'blue', fontWeight: '600' },
                      ]}
                    >
                      {props.MainRegisterText || "Register here!"}
                      
                    </Text>
                  </Text>
                  <View style={[styles.inputContainer,props.inputContainerStyle]}>
                    { modalVisible? 
                    <>
               <TextInput
                      maxLength={1}
                      // onChangeText={props.onChangeTextOTP}
                      value={OTPNumberValue?OTPNumberValue[0] : ""}
                      style={[styles.inputOTP, props.InputBoxStyleOTP]}
                      returnKeyType={props.returnKeyType || 'done'}
                      keyboardType={props.keyboardType || 'phone-pad'}
                      onSubmitEditing={props.doneButton}
                      returnKeyLabel={props.returnKeyLabel || 'default'}
                      textAlign={'center'}
                   />
                     <TextInput
                      maxLength={1}
                      onChangeText={props.onChangeTextOTP}
                      value={OTPNumberValue?OTPNumberValue[1] : ""}

                      style={[styles.inputOTP, props.InputBoxStyleOTP]}
                      returnKeyType={props.returnKeyType || 'done'}
                      keyboardType={props.keyboardType || 'phone-pad'}
                      onSubmitEditing={props.doneButton}
                      returnKeyLabel={props.returnKeyLabel || 'default'}
                      textAlign={'center'}
                   />
                     <TextInput
                      maxLength={1}
                      onChangeText={props.onChangeTextOTP}
                      value={OTPNumberValue?OTPNumberValue[2] : ""}

                      style={[styles.inputOTP, props.InputBoxStyleOTP]}
                      returnKeyType={props.returnKeyType || 'done'}
                      keyboardType={props.keyboardType || 'phone-pad'}
                      onSubmitEditing={props.doneButton}
                      returnKeyLabel={props.returnKeyLabel || 'default'}
                      textAlign={'center'}
                   />
                     <TextInput
                      maxLength={1}
                      onChangeText={props.onChangeTextOTP}
                      value={OTPNumberValue?OTPNumberValue[3] : ""}

                      style={[styles.inputOTP, props.InputBoxStyleOTP]}
                      returnKeyType={props.returnKeyType || 'done'}
                      keyboardType={props.keyboardType || 'phone-pad'}
                      onSubmitEditing={props.doneButton}
                      returnKeyLabel={props.returnKeyLabel || 'default'}
                      textAlign={'center'}
                   />
                     <TextInput
                      maxLength={1}
                      onChangeText={props.onChangeTextOTP}
                      value={OTPNumberValue?OTPNumberValue[4] : ""}

                      style={[styles.inputOTP, props.InputBoxStyleOTP]}
                      returnKeyType={props.returnKeyType || 'done'}
                      keyboardType={props.keyboardType || 'phone-pad'}
                      onSubmitEditing={props.doneButton}
                      returnKeyLabel={props.returnKeyLabel || 'default'}
                      textAlign={'center'}
                   />

                    </>
                    :

                    
                    <TextInput
                      numberOfLines={props.numberOfLines || 1}
                      maxLength={props.maxLength || 10}
                      onChangeText={props.onChangeText}
                      value={props.value}
                      style={[styles.input, props.InputBoxStyle]}
                      returnKeyType={props.returnKeyType || 'done'}
                      keyboardType={props.keyboardType || 'phone-pad'}
                      placeholder={props.placeholder || 'Enter mobile number'}
                      placeholderTextColor={
                        props.placeholderTextColor || '#6E83BC'
                      }
                      editable={props.editable || true}
                      multiline={props.multiline || false}
                      autoCapitalize={props.autoCapitalize || 'none'}
                      autoFocus={props.autoFocus || false}
                      blurOnSubmit={props.blurOnSubmit || false}
                      enablesReturnKeyAutomatically={
                        props.enablesReturnKeyAutomatically || false
                      }
                      onSubmitEditing={props.doneButton}
                      onBlur={props.onBlur}
                      onChange={props.onChange}
                      onFocus={props.onFocus}
                      returnKeyLabel={props.returnKeyLabel || 'default'}
                      secureTextEntry={props.secureTextEntry || false}
                      textAlign={props.textAlign || 'left'}
                    />
}
                  </View>
                  {
                    modalVisible?
                    <Text
                    onPress={props.ResendButtonClick?props.ResendButtonClick:()=>{}}
                    style={[
                      props.ResendButtonStyle,
                      { color: 'blue', fontWeight: '600',textAlign:'right' },
                    ]}
                  >
                 {props.resendText|| "Resend OTP?"}
                  </Text>
                  :null
                  }
                  {modalVisible ? (
                    <TouchableOpacity
                      onPress={props.onPressOTP?props.onPressOTP:()=>{}}
                      style={[styles.buttonView, props.ButtonViewStyle]}
                    >
                      <Text style={[styles.buttonText, props.ButtonTextStyle]}>
                        { props.RequestButtonText ||'Login'}
                      </Text>
                    </TouchableOpacity>
                  ) :   <TouchableOpacity
                  onPress={props.onPress?props.onPress:()=>setModalVisible(true)}
                  style={[styles.buttonView, props.ButtonViewStyle]}
                >
                  <Text style={[styles.buttonText, props.ButtonTextStyle]}>
                    { props.buttonText ||'Request OTP'}
                  </Text>
                </TouchableOpacity>}
                  {props.SignupButton ? (
                    <>
                      <Text
                        style={[
                          styles.title,
                          { fontSize: 15, textAlign: 'center', marginTop: 30 },
                          props.SignupTextStyle,
                        ]}
                      >
                        {props.SingupText || 'or continue with'}
                      </Text>
                      <View
                        style={{
                          flexDirection: 'row',
                          alignItems: 'center',
                          width: '50%',
                          alignSelf: 'center',
                          justifyContent: 'space-between',
                          marginTop: 10,
                        }}
                      >
                        <TouchableOpacity onPress={props.FbButtonClick}>
                        <Image
                          source={require('./fb.png')}
                          style={[
                            {
                              height: 30,
                              width: 30,
                              borderRadius: 20,
                            },
                            props.SocialIconStyle,
                          ]}
                        />
                        </TouchableOpacity>
                        <TouchableOpacity onPress={props.AppButtonClick}>
                        <Image
                          source={require('./app.png')}
                          style={[
                            {
                              height: 30,
                              width: 30,
                              borderRadius: 20,
                            },
                            props.SocialIconStyle,
                          ]}
                        />
                        </TouchableOpacity>
                        <TouchableOpacity onPress={props.GoogleButtonClick}>
                        <Image
                          source={require('./google.png')}
                          style={[
                            {
                              height: 30,
                              width: 30,
                              borderRadius: 20,
                            },
                            props.SocialIconStyle,
                          ]}
                        />
                        </TouchableOpacity>
                      </View>
                    </>
                  ) : null}
                </>
              </View>
       
          </View>
          </ScrollView>
        </KeyboardAvoidingView>
      </SafeAreaView>
    </>
  );
};

const styles = StyleSheet.create({
 
  viewa: {
    alignSelf: 'center',
    width: '90%',
    height: 'auto',
  },
  inputContainer: {
    flexDirection: 'row',
    alignItems: 'center',
    marginBottom: 10,
    justifyContent:'space-between'
  },

  buttonView: {
    height: 50,
    marginTop: 20,
    borderRadius: 10,
    backgroundColor: '#0818A8',
    justifyContent: 'center',
    // padding: 10,
    shadowColor: '#0818A8',
    shadowOffset: {
      width: 4,
      height: 4,
    },
    elevation: 5,
    shadowRadius: 2,
    shadowOpacity: 0.6,
  },
  buttonText: {
    textAlign: 'center',
    color: 'white',
    fontSize: 15,
    fontWeight: '800',
  },
  title: {
    fontSize: 25,
    color: 'black',
    marginBottom: 10,
  },
  Logintitle: {
    fontSize: 22,
    color: 'black',
    fontWeight: '700',
    marginTop: 30,
  },
  Texttitle: {
    fontSize: 17,
    color: 'black',
    opacity:0.9,
    marginBottom: 10,
    // fontWeight:'600',
    marginTop: 10,
  },
  RegisterText: {
    fontSize: 14,
    color: 'black',
    marginBottom: 30,
    // fontWeight:'bold',
    marginTop: 20,
  },
  inputOTP: {
    width: '16%',
    height: 50,
    backgroundColor: '#C5DDEC',
    paddingLeft: 10,
    // marginBottom: 10,
    padding: 10,
    shadowColor: '#000000',
    shadowOffset: {
      width: 1,
      height: 1,
    },
    elevation: 5,
    shadowRadius: 2,
    shadowOpacity: 0.2,

    borderRadius: 10,
  },
  input: {
    width: '100%',
    height: 50,
    backgroundColor: '#C5DDEC',
    paddingLeft: 10,
    // marginBottom: 10,
    padding: 10,
    shadowColor: '#000000',
    shadowOffset: {
      width: 1,
      height: 1,
    },
    elevation: 5,
    shadowRadius: 2,
    shadowOpacity: 0.2,

    borderRadius: 10,
  },
 
});

export default Sandy;
